Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Optimization/3.3/MultiObjective/GenerationalDistanceCalculator.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Optimization/3.3/MultiObjective/GenerationalDistanceCalculator.cs	(revision 16171)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Optimization/3.3/MultiObjective/GenerationalDistanceCalculator.cs	(revision 16171)
@@ -0,0 +1,79 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+
+#region
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+
+#endregion
+
+namespace HeuristicLab.Optimization {
+  /// <summary>
+  /// The generational Distance is defined as the pth-root of the sum of all d[i]^(p) divided by the size of the qualities
+  ///  where d[i] is the minimal distance the ith point of the evaluated qualities has to any point in the optimal pareto qualities.   
+  ///  p is a dampening factor and is normally set to 1. 
+  ///  http://shodhganga.inflibnet.ac.in/bitstream/10603/15070/28/28_appendix_h.pdf
+  /// </summary>
+  public static class GenerationalDistanceCalculator {
+    public static double CalculateGenerationalDistance<TP1, TP2>(IEnumerable<TP1> qualities, IEnumerable<TP2> bestKnownFront, double p) where TP1 : IReadOnlyList<double> where TP2 : IReadOnlyList<double> {
+      if (qualities == null || bestKnownFront == null) throw new ArgumentNullException("Fronts must not be null");
+      if (p.IsAlmost(0.0)) throw new ArgumentException("p must not be zero.");
+      var mat = bestKnownFront.ToMatrix();
+      if (mat.GetLength(0) == 0) throw new ArgumentException("Fronts must not be empty.");
+
+      alglib.kdtree tree;
+      alglib.kdtreebuild(mat, mat.GetLength(0), mat.GetLength(1), 0, 2, out tree);
+      var sum = 0.0;
+      var summand = new double[1];
+      var count = 0;
+      foreach(var point in qualities) {
+        alglib.kdtreequeryknn(tree, point.ToArray(), 1, true);
+        alglib.kdtreequeryresultsdistances(tree, ref summand);
+        sum += Math.Pow(summand[0], p);
+        count++;
+      }
+
+      if (count == 0) throw new ArgumentException("Fronts must not be empty.");
+      return Math.Pow(sum, 1 / p) / count;
+    }
+
+    public static double CalculateInverseGenerationalDistance<TP1, TP2>(IEnumerable<TP1> qualities, IEnumerable<TP2> bestKnownFront, double p) where TP1 : IReadOnlyList<double> where TP2 : IReadOnlyList<double> {
+      return CalculateGenerationalDistance(bestKnownFront, qualities, p);
+    }
+
+    internal static double[,] ToMatrix<TP>(this IEnumerable<TP> source) where TP : IReadOnlyList<double> {
+      var l = source.ToArray();
+      var firstDimension = l.Length;
+      var secondDimension = l[0].Count;
+      var result = new double[firstDimension, secondDimension];
+      for (var i = 0; i < firstDimension; ++i)
+        for (var j = 0; j < secondDimension; ++j)
+          result[i, j] = l[i][j];
+
+      return result;
+    }
+  }
+}
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Optimization/3.3/MultiObjective/HypervolumeCalculator.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Optimization/3.3/MultiObjective/HypervolumeCalculator.cs	(revision 16171)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Optimization/3.3/MultiObjective/HypervolumeCalculator.cs	(revision 16171)
@@ -0,0 +1,305 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Optimization {
+
+  public static class HypervolumeCalculator {
+
+    public static double[] CalculateNadirPoint(IEnumerable<double[]> qualities, bool[] maximization){
+      var res = maximization.Select(m => m ? double.MaxValue : double.MinValue).ToArray();
+      foreach (var quality in qualities)
+        for (var i = 0; i < quality.Length; i++)
+          if (maximization[i] == res[i] > quality[i])
+            res[i] = quality[i];
+      return res;
+    }
+
+    /// <summary>
+    /// The Hyprevolume-metric is defined as the HypervolumeCalculator enclosed between a given reference point,
+    /// that is fixed for every evaluation function and the evaluated qualities.
+    /// 
+    /// Example:
+    /// r is the reference point at (1|1) and every point p is part of the evaluated qualities
+    /// The filled area labled HV is the 2 dimensional HypervolumeCalculator enclosed by this qualities. 
+    /// 
+    /// (0|1)                (1|1)
+    ///   +      +-------------r
+    ///   |      |###### HV ###|
+    ///   |      p------+######|
+    ///   |             p+#####|
+    ///   |              |#####|
+    ///   |              p-+###|
+    ///   |                p---+
+    ///   |                 
+    ///   +--------------------1
+    /// (0|0)                (1|0)
+    /// 
+    ///  Please note that in this example both dimensions are minimized. The reference point needs to be dominated by EVERY point in the evaluated qualities 
+    /// 
+    /// </summary>
+    /// 
+    public static double CalculateHypervolume(double[][] qualities, double[] referencePoint, bool[] maximization){
+      qualities = qualities.Where(vec => DominationCalculator.Dominates(vec, referencePoint, maximization, false) == DominationResult.Dominates).ToArray();
+      if (!qualities.Any()) return 0;//TODO replace with negative computation
+      if (maximization.Length == 2)
+        return Calculate2D(qualities, referencePoint, maximization);
+
+      if (Array.TrueForAll(maximization, x => !x))
+        return CalculateMultiDimensional(qualities, referencePoint);
+      throw new NotImplementedException("HypervolumeCalculator calculation for more than two dimensions is supported only with minimization problems.");
+    }
+
+    public static double Calculate2D(double[][] front, double[] referencePoint, bool[] maximization) {
+      if (front == null) throw new ArgumentNullException("Front must not be null.");
+      if (!front.Any()) throw new ArgumentException("Front must not be empty.");
+
+      if (referencePoint == null) throw new ArgumentNullException("ReferencePoint must not be null.");
+      if (referencePoint.Length != 2) throw new ArgumentException("ReferencePoint must have exactly two dimensions.");
+
+      var set = front.ToArray();
+      if (set.Any(s => s.Length != 2)) throw new ArgumentException("Points in qualities must have exactly two dimensions.");
+
+      Array.Sort(set, new DimensionComparer(0, maximization[0]));
+
+      double sum = 0;
+      for (var i = 0; i < set.Length - 1; i++) 
+        sum += Math.Abs((set[i][0] - set[i + 1][0])) * Math.Abs((set[i][1] - referencePoint[1]));
+      
+      var lastPoint = set[set.Length - 1];
+      sum += Math.Abs(lastPoint[0] - referencePoint[0]) * Math.Abs(lastPoint[1] - referencePoint[1]);
+
+      return sum;
+    }
+
+    public static double CalculateMultiDimensional(double[][] front, double[] referencePoint) {
+      if (referencePoint == null || referencePoint.Length < 3) throw new ArgumentException("ReferencePoint unfit for complex HypervolumeCalculator calculation");
+
+      var objectives = referencePoint.Length;
+      var fronList = front.ToList();
+      fronList.StableSort(new DimensionComparer(objectives - 1, false));
+
+      var regLow = Enumerable.Repeat(1E15, objectives).ToArray();
+      foreach (var p in fronList) {
+        for (var i = 0; i < regLow.Length; i++) {
+          if (p[i] < regLow[i]) regLow[i] = p[i];
+        }
+      }
+
+      return Stream(regLow, referencePoint, fronList, 0, referencePoint[objectives - 1], (int)Math.Sqrt(fronList.Count), objectives);
+    }
+
+    private static double Stream(double[] regionLow, double[] regionUp, List<double[]> front, int split, double cover, int sqrtNoPoints, int objectives) {
+      var coverOld = cover;
+      var coverIndex = 0;
+      var coverIndexOld = -1;
+      int c;
+      double result = 0;
+
+      var dMeasure = GetMeasure(regionLow, regionUp, objectives);
+      while (cover == coverOld && coverIndex < front.Count()) {
+        if (coverIndexOld == coverIndex) break;
+        coverIndexOld = coverIndex;
+        if (Covers(front[coverIndex], regionLow, objectives)) {
+          cover = front[coverIndex][objectives - 1];
+          result += dMeasure * (coverOld - cover);
+        } else coverIndex++;
+      }
+
+      for (c = coverIndex; c > 0; c--) if (front[c - 1][objectives - 1] == cover) coverIndex--;
+      if (coverIndex == 0) return result;
+
+      var allPiles = true;
+      var piles = new int[coverIndex];
+      for (var i = 0; i < coverIndex; i++) {
+        piles[i] = IsPile(front[i], regionLow, regionUp, objectives);
+        if (piles[i] == -1) {
+          allPiles = false;
+          break;
+        }
+      }
+
+      if (allPiles) {
+        var trellis = new double[regionUp.Length];
+        for (var j = 0; j < trellis.Length; j++) trellis[j] = regionUp[j];
+        double current = 0;
+        double next = 0;
+        var i = 0;
+        do {
+          current = front[i][objectives - 1];
+          do {
+            if (front[i][piles[i]] < trellis[piles[i]]) trellis[piles[i]] = front[i][piles[i]];
+            i++;
+            if (i < coverIndex) next = front[i][objectives - 1];
+            else { next = cover; break; }
+          } while (next == current);
+          result += ComputeTrellis(regionLow, regionUp, trellis, objectives) * (next - current);
+        } while (next != cover);
+      } else {
+        double bound = -1;
+        var boundaries = new double[coverIndex];
+        var noBoundaries = new double[coverIndex];
+        var boundIdx = 0;
+        var noBoundIdx = 0;
+
+        do {
+          for (var i = 0; i < coverIndex; i++) {
+            var contained = ContainesBoundary(front[i], regionLow, split);
+            if (contained == 0) boundaries[boundIdx++] = front[i][split];
+            else if (contained == 1) noBoundaries[noBoundIdx++] = front[i][split];
+          }
+          if (boundIdx > 0) bound = GetMedian(boundaries, boundIdx);
+          else if (noBoundIdx > sqrtNoPoints) bound = GetMedian(noBoundaries, noBoundIdx);
+          else split++;
+        } while (bound == -1.0);
+
+        List<double[]> pointsChildLow, pointsChildUp;
+        pointsChildLow = new List<double[]>();
+        pointsChildUp = new List<double[]>();
+        var regionUpC = new double[regionUp.Length];
+        for (var j = 0; j < regionUpC.Length; j++) regionUpC[j] = regionUp[j];
+        var regionLowC = new double[regionLow.Length];
+        for (var j = 0; j < regionLowC.Length; j++) regionLowC[j] = regionLow[j];
+
+        for (var i = 0; i < coverIndex; i++) {
+          if (PartCovers(front[i], regionUpC, objectives)) pointsChildUp.Add(front[i]);
+          if (PartCovers(front[i], regionUp, objectives)) pointsChildLow.Add(front[i]);
+        }
+
+        if (pointsChildUp.Count > 0) result += Stream(regionLow, regionUpC, pointsChildUp, split, cover, sqrtNoPoints, objectives);
+        if (pointsChildLow.Count > 0) result += Stream(regionLowC, regionUp, pointsChildLow, split, cover, sqrtNoPoints, objectives);
+      }
+      return result;
+    }
+
+    private static double GetMedian(double[] vector, int length) {
+      return vector.Take(length).Median();
+    }
+
+    private static double ComputeTrellis(double[] regionLow, double[] regionUp, double[] trellis, int objectives) {
+      var bs = new bool[objectives - 1];
+      for (var i = 0; i < bs.Length; i++) bs[i] = true;
+
+      double result = 0;
+      var noSummands = BinarayToInt(bs);
+      int oneCounter; double summand;
+      for (uint i = 1; i <= noSummands; i++) {
+        summand = 1;
+        IntToBinary(i, bs);
+        oneCounter = 0;
+        for (var j = 0; j < objectives - 1; j++) {
+          if (bs[j]) {
+            summand *= regionUp[j] - trellis[j];
+            oneCounter++;
+          } else {
+            summand *= regionUp[j] - regionLow[j];
+          }
+        }
+        if (oneCounter % 2 == 0) result -= summand;
+        else result += summand;
+
+      }
+      return result;
+    }
+
+    private static void IntToBinary(uint i, bool[] bs) {
+      for (var j = 0; j < bs.Length; j++) bs[j] = false;
+      var rest = i;
+      var idx = 0;
+      while (rest != 0) {
+        bs[idx] = rest % 2 == 1;
+        rest = rest / 2;
+        idx++;
+      }
+    }
+
+    private static uint BinarayToInt(bool[] bs) {
+      uint result = 0;
+      for (var i = 0; i < bs.Length; i++) {
+        result += bs[i] ? ((uint)1 << i) : 0;
+      }
+      return result;
+    }
+
+    private static int IsPile(double[] cuboid, double[] regionLow, double[] regionUp, int objectives) {
+      var pile = cuboid.Length;
+      for (var i = 0; i < objectives - 1; i++) {
+        if (cuboid[i] > regionLow[i]) {
+          if (pile != objectives) return 1;
+          pile = i;
+        }
+      }
+      return pile;
+    }
+
+    private static double GetMeasure(double[] regionLow, double[] regionUp, int objectives) {
+      double volume = 1;
+      for (var i = 0; i < objectives - 1; i++) {
+        volume *= (regionUp[i] - regionLow[i]);
+      }
+      return volume;
+    }
+
+    private static int ContainesBoundary(double[] cub, double[] regionLow, int split) {
+      if (regionLow[split] >= cub[split]) return -1;
+      else {
+        for (var j = 0; j < split; j++) {
+          if (regionLow[j] < cub[j]) return 1;
+        }
+      }
+      return 0;
+    }
+
+    private static bool PartCovers(double[] v, double[] regionUp, int objectives) {
+      for (var i = 0; i < objectives - 1; i++) {
+        if (v[i] >= regionUp[i]) return false;
+      }
+      return true;
+    }
+
+    private static bool Covers(double[] v, double[] regionLow, int objectives) {
+      for (var i = 0; i < objectives - 1; i++) {
+        if (v[i] > regionLow[i]) return false;
+      }
+      return true;
+    }
+
+    private class DimensionComparer : IComparer<double[]> {
+      private readonly int dimension;
+      private readonly int descending;
+
+      public DimensionComparer(int dimension, bool descending) {
+        this.dimension = dimension;
+        this.descending = descending ? -1 : 1;
+      }
+
+      public int Compare(double[] x, double[] y){
+        return x[dimension].CompareTo(y[dimension]) * descending;
+      }
+    }
+
+  }
+}
+
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Optimization/3.3/MultiObjective/SpacingCalculator.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Optimization/3.3/MultiObjective/SpacingCalculator.cs	(revision 16171)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Optimization/3.3/MultiObjective/SpacingCalculator.cs	(revision 16171)
@@ -0,0 +1,56 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Optimization {
+
+  /// <summary>
+  /// SpacingCalculator is defined as the standarddeviation of all d[i] 
+  /// where d[i] is the minimum eukildean distance any point i has 
+  /// to all OTHER points in the same front 
+  /// </summary>
+  public static class SpacingCalculator {
+
+    public static double CalculateSpacing<TP>(IEnumerable<TP> qualities) where TP: IReadOnlyList<double> {
+      if (qualities == null) throw new ArgumentException("Front must not be null.");
+      var l = qualities.ToList();
+      if (l.Count == 0) throw new ArgumentException("Front must not be empty.");
+      if (l.Count == 1) return 0;
+
+      var mat = l.ToMatrix();
+      alglib.kdtree tree;
+      alglib.kdtreebuild(mat, mat.GetLength(0), mat.GetLength(1), 0, 2, out tree);
+      var summand = new double[2];
+      var dists = new List<double>();
+      foreach (var point in l) {
+        alglib.kdtreequeryknn(tree, point.ToArray(), 2, true);
+        alglib.kdtreequeryresultsdistances(tree, ref summand);
+        dists.Add(summand[1]);
+      }
+      return dists.StandardDeviationPop();
+    }
+
+    
+  }
+}
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/CrowdingAnalyzer.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/CrowdingAnalyzer.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/CrowdingAnalyzer.cs	(revision 16171)
@@ -33,8 +33,4 @@
   public class CrowdingAnalyzer : MOTFAnalyzer {
 
-    public ILookupParameter<DoubleMatrix> BoundsParameter {
-      get { return (ILookupParameter<DoubleMatrix>)Parameters["Bounds"]; }
-    }
-
     public IResultParameter<DoubleValue> CrowdingResultParameter {
       get { return (IResultParameter<DoubleValue>)Parameters["Crowding"]; }
@@ -51,18 +47,12 @@
 
     public CrowdingAnalyzer() {
-      Parameters.Add(new LookupParameter<DoubleMatrix>("Bounds",
-        "The bounds of the solution given as either one line for all variables or a line for each variable. The first column specifies lower bound, the second upper bound."));
-      Parameters.Add(new ResultParameter<DoubleValue>("Crowding", "The average corwding value of all points (excluding infinities)"));
+      Parameters.Add(new ResultParameter<DoubleValue>("Crowding", "The average corwding distance of all points (excluding infinities)"));
       CrowdingResultParameter.DefaultValue = new DoubleValue(double.NaN);
-
     }
 
     public override IOperation Apply() {
       var qualities = QualitiesParameter.ActualValue;
-      var bounds = BoundsParameter.ActualValue;
-
-      var crowdingDistance = Crowding.Calculate(qualities.Select(x => x.ToArray()), bounds.CloneAsMatrix());
+      var crowdingDistance = CrowdingCalculator.CalculateCrowding(qualities);
       CrowdingResultParameter.ActualValue.Value = crowdingDistance;
-
       return base.Apply();
     }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/GenerationalDistanceAnalyzer.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/GenerationalDistanceAnalyzer.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/GenerationalDistanceAnalyzer.cs	(revision 16171)
@@ -64,12 +64,7 @@
     public override IOperation Apply() {
       var qualities = QualitiesParameter.ActualValue;
-      int objectives = qualities[0].Length;
-
-      var optimalfront = TestFunctionParameter.ActualValue.OptimalParetoFront(objectives);
+      var optimalfront = TestFunctionParameter.ActualValue.OptimalParetoFront(qualities[0].Length);
       if (optimalfront == null) return base.Apply();
-
-      var distance = GenerationalDistance.Calculate(qualities.Select(x => x.CloneAsArray()), optimalfront, Dampening);
-      GenerationalDistanceResultParameter.ActualValue.Value = distance;
-
+      GenerationalDistanceResultParameter.ActualValue.Value = GenerationalDistanceCalculator.CalculateGenerationalDistance(qualities, optimalfront, Dampening);
       return base.Apply();
     }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/HypervolumeAnalyzer.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/HypervolumeAnalyzer.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/HypervolumeAnalyzer.cs	(revision 16171)
@@ -76,15 +76,13 @@
       var qualities = QualitiesParameter.ActualValue;
       var testFunction = TestFunctionParameter.ActualValue;
-      int objectives = qualities[0].Length;
+      var objectives = qualities[0].Length;
       var referencePoint = ReferencePointParameter.ActualValue;
 
-      double best = BestKnownHypervolumeResultParameter.ActualValue.Value;
+      var best = BestKnownHypervolumeResultParameter.ActualValue.Value;
       if (referencePoint.SequenceEqual(testFunction.ReferencePoint(objectives))) {
         best = Math.Max(best, testFunction.OptimalHypervolume(objectives));
       }
 
-      IEnumerable<double[]> front = NonDominatedSelect.SelectNonDominatedVectors(qualities.Select(q => q.ToArray()), testFunction.Maximization(objectives), true);
-
-      double hv = Hypervolume.Calculate(front, referencePoint.ToArray(), testFunction.Maximization(objectives));
+      var hv = HypervolumeCalculator.CalculateHypervolume(qualities.Select(x=>x.CloneAsArray()).ToArray(), referencePoint.ToArray(), testFunction.Maximization(objectives));
 
       if (hv > best) {
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/InvertedGenerationalDistanceAnalyzer.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/InvertedGenerationalDistanceAnalyzer.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/InvertedGenerationalDistanceAnalyzer.cs	(revision 16171)
@@ -47,12 +47,4 @@
     }
 
-    public InvertedGenerationalDistanceAnalyzer() {
-      Parameters.Add(new FixedValueParameter<DoubleValue>("Dampening", "", new DoubleValue(1)));
-      Parameters.Add(new ResultParameter<DoubleValue>("Inverted Generational Distance", "The genrational distance between the current front and the optimal front"));
-      InvertedGenerationalDistanceResultParameter.DefaultValue = new DoubleValue(double.NaN);
-
-    }
-
-
     [StorableConstructor]
     protected InvertedGenerationalDistanceAnalyzer(bool deserializing) : base(deserializing) { }
@@ -62,19 +54,17 @@
     }
 
+    public InvertedGenerationalDistanceAnalyzer() {
+      Parameters.Add(new FixedValueParameter<DoubleValue>("Dampening", "", new DoubleValue(1)));
+      Parameters.Add(new ResultParameter<DoubleValue>("Inverted Generational Distance", "The genrational distance between the current front and the optimal front"));
+      InvertedGenerationalDistanceResultParameter.DefaultValue = new DoubleValue(double.NaN);
+    }
+
     public override IOperation Apply() {
       var qualities = QualitiesParameter.ActualValue;
-      var testFunction = TestFunctionParameter.ActualValue;
-      int objectives = qualities[0].Length;
-
-      var optimalfront = testFunction.OptimalParetoFront(objectives);
+      var optimalfront = TestFunctionParameter.ActualValue.OptimalParetoFront(qualities[0].Length);
       if (optimalfront == null) return base.Apply();
-
-      var invertedGenerationalDistance = InvertedGenerationalDistance.Calculate(qualities.Select(q => q.ToArray()), optimalfront, DampeningParameter.Value.Value);
-      InvertedGenerationalDistanceResultParameter.ActualValue.Value = invertedGenerationalDistance;
-
+      InvertedGenerationalDistanceResultParameter.ActualValue.Value = GenerationalDistanceCalculator.CalculateInverseGenerationalDistance(qualities, optimalfront, Dampening);
       return base.Apply();
     }
-
-
   }
 }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/ScatterPlotAnalyzer.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/ScatterPlotAnalyzer.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/ScatterPlotAnalyzer.cs	(revision 16171)
@@ -59,8 +59,8 @@
       var individuals = IndividualsParameter.ActualValue;
       var testFunction = TestFunctionParameter.ActualValue;
-      int objectives = qualities[0].Length;
-      int problemSize = individuals[0].Length;
+      var objectives = qualities[0].Length;
+      var problemSize = individuals[0].Length;
 
-      double[][] optimalFront = new double[0][];
+      var optimalFront = new double[0][];
       var front = testFunction.OptimalParetoFront(objectives);
       if (front != null) optimalFront = front.ToArray();
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/SpacingAnalyzer.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/SpacingAnalyzer.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Analyzers/SpacingAnalyzer.cs	(revision 16171)
@@ -51,7 +51,5 @@
     public override IOperation Apply() {
       var qualities = QualitiesParameter.ActualValue;
-      var spacing = Spacing.Calculate(qualities.Select(q => q.ToArray()));
-      SpacingResultParameter.ActualValue.Value = spacing;
-
+      SpacingResultParameter.ActualValue.Value = SpacingCalculator.CalculateSpacing(qualities);
       return base.Apply();
     }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/HeuristicLab.Problems.TestFunctions.MultiObjective-3.3.csproj
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/HeuristicLab.Problems.TestFunctions.MultiObjective-3.3.csproj	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/HeuristicLab.Problems.TestFunctions.MultiObjective-3.3.csproj	(revision 16171)
@@ -17,5 +17,5 @@
     <DebugType>full</DebugType>
     <Optimize>false</Optimize>
-    <OutputPath>..\..\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\bin\</OutputPath>
     <DefineConstants>DEBUG;TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
@@ -90,7 +90,4 @@
     <Reference Include="HeuristicLab.Core-3.3">
       <HintPath>..\..\..\..\trunk\bin\HeuristicLab.Core-3.3.dll</HintPath>
-    </Reference>
-    <Reference Include="HeuristicLab.Data-3.3">
-      <HintPath>..\..\..\..\trunk\bin\HeuristicLab.Data-3.3.dll</HintPath>
     </Reference>
     <Reference Include="HeuristicLab.Encodings.RealVectorEncoding-3.3">
@@ -134,9 +131,4 @@
     <Compile Include="Interfaces\IConstrainedTestFunction.cs" />
     <Compile Include="Interfaces\IMultiObjectiveTestFunctionAnalyzer.cs" />
-    <Compile Include="Calculators\Crowding.cs" />
-    <Compile Include="Calculators\Spacing.cs" />
-    <Compile Include="Calculators\HyperVolume.cs" />
-    <Compile Include="Calculators\InvertedGenerationalDistance.cs" />
-    <Compile Include="Calculators\GenerationalDistance.cs" />
     <Compile Include="ParetoFrontScatterPlot.cs" />
     <Compile Include="Utilities.cs" />
@@ -206,4 +198,8 @@
       <Name>HeuristicLab.Analysis-3.3</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Data\3.3\HeuristicLab.Data-3.3.csproj">
+      <Project>{bbab9df5-5ef3-4ba8-ade9-b36e82114937}</Project>
+      <Name>HeuristicLab.Data-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Optimization\3.3\HeuristicLab.Optimization-3.3.csproj">
       <Project>{14ab8d24-25bc-400c-a846-4627aa945192}</Project>
